package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.TestDeploy;
import com.izouma.awesomeadmin.service.TestDeployService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testDeploy")
public class TestDeployController {

    @Autowired
    private TestDeployService testDeployService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(TestDeploy record) {
        List<TestDeploy> pp = testDeployService.getTestDeployList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestDeploy", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestDeploy(@RequestParam(required = false, value = "id") String id) {
        TestDeploy data = testDeployService.getTestDeployById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(TestDeploy record) {
        TestDeploy data = testDeployService.getTestDeploy(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, TestDeploy record) {
        Map<String, Object> result = new HashMap<>();

        List<TestDeploy> pp =testDeployService.getTestDeployByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(TestDeploy record) {
        boolean num = testDeployService.createTestDeploy(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestDeploy(TestDeploy record) {
        boolean num = testDeployService.updateTestDeploy(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestDeploy(@RequestParam(required = true, value = "id") String id) {

        boolean num = testDeployService.deleteTestDeploy(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, TestDeploy record) throws Exception {

    List<TestDeploy> testDeploys = testDeployService.getTestDeployList(record);


        String sheetName = "test_deploy";
        String titleName = "test_deploy数据表";
        String fileName = "test_deploy表";
        int columnNumber = 3;
        int[] columnWidth = { 20,  20,  20 };
        String[] columnName = {  "id",   "删除标识" ,   "名称"  };
        String[][] dataList = new String[testDeploys.size()][3];

        for (int i = 0; i < testDeploys.size(); i++) {

            dataList[i][0] = String.valueOf(testDeploys.get(i).getId());
            dataList[i][1] = String.valueOf(testDeploys.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(testDeploys.get(i).getName());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

